#ifndef STARTSCREEN
#define STARTSCREEN
/**
 * This file implments and initializes the start screen for the game
 * When player 1 presses start, the start phase ends
 */
 
 #include "vgaDrive.h"
 #include "includes.h"
 
 #define START_LOOP_DELAY_MS 100

/**
 * runs only once, puts an image on the start screen
 * used for background or permanant static images
 */
void initStartScreen(short int* pixelMap);

/**
 * loops, redrawing the start screen, possible to allow animations
 * when start is press should cease to run
 */
void runStartScreen(short int* pixelMap,dmaState dstate, OS_EVENT * semVGA,OS_EVENT * controller1semaphore);

/**
 * goes true when the start button has been pressed on the first contoller
 */
int detectStart(OS_EVENT * controller1semaphore);

/**
 * gets rid of the start screen
 */
void eraseStart(short int* pixelMap);

#endif
