/**
This file will recieve and interpret
data from the wireless controller
*/

#include "userIO.h"

#include <string.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <errno.h>


#define M_PI 3.1415

OS_EVENT *controller1semaphore;
OS_EVENT *controller2semaphore;

void controller1_task( void *pdata )
{
     //clear out teh struct to remove junk.
     

    memset(&controller1state, 0, sizeof(ControllerState));
    
    FILE* fp = fopen(CONTROLLER1UART_NAME, "r");
    int errorCount = 0;
    
    int oldX = 0;
    int oldY = 0;
    int oldZ = 0;
    double filterRate = 0.5;
    
    char buffer[128];
    while(1)
    {
       printf("%d\n",feof(fp));
        while( fgets( buffer, sizeof(buffer), fp ) != NULL )
        {

            int xA;
            int yA;
            int zA;

            
            int fireButton;
            int startButton;
            
            double roll = 0.0;
            double pitch = 0.0;
            //printf("%s\n",buffer);
            if( (errorCount % 50) == 0 && errorCount != 0)
            {
                printf("Error: %d\n", errorCount);
                printf("Buffer: %s\n", buffer);
            }
            
            
            if( sscanf(buffer, "%d:%d:%d:%d:%d", &xA, &yA, &zA, &fireButton, &startButton) != 5 )
            {
               //int *red_leds = RED_LEDS_BASE;
               //*red_leds = (*red_leds) ^ 0x20000;

               errorCount++;
            }
            else
            {
                int* green_leds = GREEN_LEDS_BASE;
                *green_leds ^= 1 << 1; //Toggle LED1
                
                
                if( xA > 127 )
                    xA = -1 * (255 - xA);
                if( yA > 127 )
                    yA = -1 * (255 - yA);
                if( zA > 127 )
                    zA = -1 * (255 - zA);
                    
                //lowpass
                xA = floor(filterRate * xA + (1.0 - filterRate) * oldX) - CONTROLLER1_X_OFFSET;
                yA = floor(filterRate * yA + (1.0 - filterRate) * oldY) - CONTROLLER1_Y_OFFSET;
                zA = floor(filterRate * zA + (1.0 - filterRate) * oldZ) - CONTROLLER1_Z_OFFSET;
                
                oldX = xA;
                oldY = yA;
                oldZ = zA;
                
                
                pitch = atan( xA / ( sqrt( yA*yA + zA*zA ) ) ) * (180/M_PI);
                roll = atan( yA / ( sqrt( xA*xA + zA*zA) ) ) * (180/M_PI);
                
                //printf("X: %d Y: %d z: %d roll: %f pitch: %f\n", xA, yA, zA, roll, pitch );
                
                //populate the struct.
                
                //HEY!!!!
                //TODO: you should be checking the third argument for error values!
               
                OSSemPend( controller1semaphore, 0, NULL );
                
                controller1state.roll = roll;
                controller1state.pitch = pitch;
                controller1state.fire = fireButton;
                controller1state.start = startButton;
                
                OSSemPost( controller1semaphore );
                
            }
            memset(buffer, 0, sizeof(buffer));
        }
    }
    
}

void controller2_task( void *pdata )
{
     //clear out teh struct to remove junk.
    memset(&controller2state, 0, sizeof(ControllerState));
    
    FILE* fp = fopen(CONTROLLER2UART_NAME, "r");
    int errorCount = 0;
    
    int oldX = 0;
    int oldY = 0;
    int oldZ = 0;
    double filterRate = 0.5;
    
    char buffer[128];
    while(1)
    {
        while( fgets( buffer, sizeof( buffer ), fp ) != NULL )
        {
            
            int xA;
            int yA;
            int zA;

            
            int fireButton;
            int startButton;
            
            double roll = 0.0;
            double pitch = 0.0;
            
            if( (errorCount % 50) == 0 )
            {
                printf("Error: %d\n", errorCount);
                printf("Buffer: %s\n", buffer);
            }
            
            if( sscanf(buffer, "%d:%d:%d:%d:%d", &xA, &yA, &zA, &fireButton, &startButton) != 5 )
            {
              // int *red_leds = RED_LEDS_BASE;
              // *red_leds = (*red_leds) ^ 0x20000;
               errorCount++;
            }
            else
            {
                int* green_leds = GREEN_LEDS_BASE;
                *green_leds ^= 1 << 2; //toggle LED2
                
         
                
                if( xA > 127 )
                    xA = -1 * (255 - xA);
                if( yA > 127 )
                    yA = -1 * (255 - yA);
                if( zA > 127 )
                    zA = -1 * (255 - zA);
                    
                //lowpass
                xA = floor(filterRate * xA + (1.0 - filterRate) * oldX) - CONTROLLER2_X_OFFSET;
                yA = floor(filterRate * yA + (1.0 - filterRate) * oldY) - CONTROLLER2_Y_OFFSET;
                zA = floor(filterRate * zA + (1.0 - filterRate) * oldZ) - CONTROLLER2_Z_OFFSET;
                
                oldX = xA;
                oldY = yA;
                oldZ = zA;
                
                
             
                
                pitch = atan( xA / ( sqrt( yA*yA + zA*zA ) ) ) * (180/M_PI);
                roll = atan( yA / ( sqrt( xA*xA + zA*zA) ) ) * (180/M_PI);
                
                //printf("X: %d Y: %d z: %d roll: %f pitch: %f\n", xA, yA, zA, roll, pitch );
                
                //populate the struct.
                
                //HEY!!!!
                //TODO: you should be checking the third argument for error values!
                
                OSSemPend( controller2semaphore, 0, NULL );
                
                controller2state.roll = roll;
                controller2state.pitch = pitch;
                controller2state.fire = fireButton;
                controller2state.start = startButton;
                
                OSSemPost( controller2semaphore );
                
               
            }
            memset(buffer, 0, sizeof(buffer));
        }
    }
       
}
